"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
// Define um enum de variáveis usando um objeto em Node.js
const VariableName = Object.freeze({
  STARTUP: 0x0008,
  WRITE_KEY: 0x0538,
  CONSUMER_INFO: 0x0410,
  ENERGY_SMC: 0xFA08,
  ALARM_SMC_CPU: 0x0148,
  ALARM_SMC_METER: 0x0168,
  NIC_INFO: 0x0308,
  NIC_DATA: 0x0310,
  NIC_SETUP: 0x0318,
  ALARM_FLAG: 0x3108,
  TEMPERATUE_VALUE: 0x3208,
  RELAY_STATE: 0x3408,
  MULTICAST_GROUP_BITARRAY: 0x3508,
  MULTICAST_GROUP_ADDR_1_8: 0x3510,
  MULTICAST_GROUP_ADDR_9_56: 0x3540,
  MULTICAST_GROUP_ADDR_57_64: 0x3548,
  LDR_UPPER: 0x3608,
  LDR_BOTTOM: 0x3610,
  LDR_MIN: 0x3618,
  HW_LIST: 0x1608,
  VOLTAGE_RMS_VALUE: 0x4108,
  VOLTAGE_RMS_SCALER_UNIT: 0x4110,
  VOLTAGE_RMS_STATUS: 0x4118,
  VOLTAGE_RMS_CAPTURE_TIME: 0x4120,
  VOLTAGE_FREQUENCY_VALUE: 0x4208,
  VOLTAGE_FREQUENCY_SCALER_UNIT: 0x4210,
  VOLTAGE_FREQUENCY_STATUS: 0x4218,
  VOLTAGE_FREQUENCY_CAPTURE_TIME: 0x4220,
  LINE_CURRENT_RMS_VALUE: 0x4308,
  LINE_CURRENT_RMS_SCALER_UNIT: 0x4310,
  LINE_CURRENT_RMS_STATUS: 0x4318,
  LINE_CURRENT_RMS_CAPTURE_TIME: 0x4320,
  LINE_MEAN_ACTIVE_POWER_VALUE: 0x4408,
  LINE_MEAN_ACTIVE_POWER_SCALER_UNIT: 0x4410,
  LINE_MEAN_ACTIVE_POWER_STATUS: 0x4418,
  LINE_MEAN_ACTIVE_POWER_CAPTURE_TIME: 0x4420,
  LINE_MEAN_REACTIVE_POWER_VALUE: 0x4508,
  LINE_MEAN_REACTIVE_POWER_SCALER_UNIT: 0x4510,
  LINE_MEAN_REACTIVE_POWER_STATUS: 0x4518,
  LINE_MEAN_REACTIVE_POWER_CAPTURE_TIME: 0x4520,
  LINE_MEAN_APPARENT_POWER_VALUE: 0x4608,
  LINE_MEAN_APPARENT_POWER_SCALER_UNIT: 0x4610,
  LINE_MEAN_APPARENT_POWER_STATUS: 0x4618,
  LINE_MEAN_APPARENT_POWER_CAPTURE_TIME: 0x4620,
  LINE_POWER_FACTOR_VALUE: 0x4708,
  LINE_POWER_FACTOR_SCALER_UNIT: 0x4710,
  LINE_POWER_FACTOR_STATUS: 0x4718,
  LINE_POWER_FACTOR_CAPTURE_TIME: 0x4720,
  FORWARD_ACTIVE_ENERGY_VALUE: 0x4808,
  FORWARD_ACTIVE_ENERGY_SCALER_UNIT: 0x4810,
  FORWARD_ACTIVE_ENERGY_STATUS: 0x4818,
  FORWARD_ACTIVE_ENERGY_CAPTURE_TIME: 0x4820,
  FORWARD_REACTIVE_ENERGY_VALUE: 0x4908,
  FORWARD_REACTIVE_ENERGY_SCALER_UNIT: 0x4910,
  FORWARD_REACTIVE_ENERGY_STATUS: 0x4918,
  FORWARD_REACTIVE_ENERGY_CAPTURE_TIME: 0x4920,
  METER_DATA_TABLE_CELL_VALUES: 0x4A08,
  METER_DATA_TABLE_CELL_DEFINITION: 0x4A10,
  METER_DATA_SCALER_UNIT: 0x4A18,
  METER_ALARM_VOLTAGE_RMS_THRESHOLDS: 0x5108,
  METER_ALARM_VOLTAGE_RMS_MONITORED_VALUE: 0x5110,
  METER_ALARM_VOLTAGE_RMS_ACTIONS: 0x5118,
  METER_LINE_CURRENT_RMS_THRESHOLDS: 0x5208,
  METER_LINE_CURRENT_RMS_MONITORED_VALUE: 0x5210,
  METER_LINE_CURRENT_RMS_ACTIONS: 0x5218,
  METER_ALARM_LINE_POWER_FACTOR_THRESHOLDS: 0x5308,
  METER_ALARM_LINE_POWER_FACTOR_MONITORED_VALUE: 0x5310,
  METER_ALARM_LINE_POWER_FACTOR_ACTIONS: 0x5318,
  METER_ALARM_LINE_MEAN_APPARENT_POWER_THRESHOLDS: 0x5408,
  METER_ALARM_LINE_MEAN_APPARENT_POWER_MONITORED_VALUE: 0x5410,
  METER_ALARM_LINE_MEAN_APPARENT_POWER_ACTIONS: 0x5418,
  METER_ALARM_TEMPERATURE_THRESHOLDS: 0x5508,
  METER_ALARM_TEMPERATURE_MONITORED_VALUE: 0x5510,
  METER_ALARM_TEMPERATURE_ACTIONS: 0x5518,
  METER_ALARM_FAKE_ON_OFF_THRESHOLDS: 0x5608,
  METER_ALARM_FAKE_ON_OFF_MONITORED_VALUE: 0x5610,
  METER_ALARM_FAKE_ON_OFF_ACTIONS: 0x5618,
  LORAWAN_SETUP_CHANNELS: 0x1708,
  LORAWAN_SETUP_LINK_CHECK: 0x1710,
  SMI_INFO: 0x0408,
  SMC_INFO: 0x0408,
  KEYS_FOUND: 0x0508,
  ALARMS_SMC: 0X0708,
  COLLECTIVE_CUT: 0x0718,
  ROLLBACK: 0x0728,
  SET_RELAY: 0x0A18,
  OVER_CURRENT_ALARM: 0x0710,
  RELAY_STATUS: 0x0A08,
  UPDATE_DATE_TIME: 0x0B08,
  INSTANT_MEASURE: 0x0C08,
  NIC_RESET: 0x0338,
  DOOR_STATUS: 0x0718,
  SET_CURRENT: 0x1108,
  SET_SMI_RELAY: 0x1218,
  RELAY_STATUS_SMI: 0x1208,
  LAST_GASP: 0x1508,
  QEE_INDICATOR: 0x0F08,
  HEART_BEAT: 0x1908,
  SET_SMC_RELAY: 0x0A18,
  SMC_METER_ENERGY: 0xFAF0,
  SMC_METER_RELAY_STATUS: 0x0018,
  UPLINKPERIOD: 0x1808,
  RECOVER_MASS_MEMORY: 0X1838,
  RECOVER_FROZEN_DATA: 0X1840,
  RECOVER_EVENT: 0x1848,
  UPLINK_PERIOD_EASY_TRAFO: 0x0608,
  KEYS_ABSOLUTE: 0x1008,
  KEY_ABSOLUTE: 0x1038,
  ALARM_METER: 0x1408,
  GET_BLOCK_SIZE: 0x0808,
  IMAGE_TRANSFER_INITIATE: 0x0840,
  IMAGE_TRANSFER_DATA: 0x0848,
  IMAGE_TRANSFER_FIRST_NOT_TRANSFERRED: 0x0818,
  IMAGE_TRANSFER_VERIFY: 0x0850,
  IMAGE_TRANSFER_ACTIVATE: 0x0858,
  TIMESTAMP: 0x3308,
  NIC_SERIAL: 0x0328,
  RELAY_STATE_WITH_LAST_SWITCH_ON: 0x3418,
  RELAY_STATE_WITH_LAST_SWITCH_ON_ADN_OFF: 0x3410,
  ALARM_FAKE_ON_OFF: 0x3120,
  SET_MULTICAST_APPLICATION_GROUP: 0x3550,
  RELAY_STATE_WITH_DELAY: 0x3428,
  ALARM_VOLTAGE_MONITOR: 0x3110,
  ALARM_FAKE_ON_OFF_THRESHOLD: 0x3128,
  SET_LINK_CHECK_INTERVAL: 0x1710,
  FORWARD_ACTIVE_ENERGY_RESET: 0x4838,
  SGI_IP_INFO: 0x0408,
  SGI_IP_STARTUP: 0x6108,
  SWITCH_RELAY: 0x6208,
  SGI_IP_INFO_FW_VERSION: 0x0408,
  SGI_IP_INFO_RESET_FLAG: 0x0410,
  SGI_IP_INFO_MC_SETUP: 0x0418,
  SGI_IP_DATA_BURNING_HOURS: 0x0420,
  SGI_IP_DATA_SWITCHING_QTY: 0x0428,
  SGI_IP_DATA_LDR_VALUE: 0x0430,
  SGI_IP_SETUP_LDR_BYPASS: 0x0438,
  SGI_IP_SETUP_DIMMER_VALUE: 0x0440,
  SGI_IP_SETUP_PERIODIC_TIME_VALUE: 0x0448,
  SGI_IP_ERROR: 0x0460,
  SGI_IP_UI: 0x0458,
  SGI_IP_RESET: 0x0468,
  HEART_BEAT_INTERVAL: 0x1910,
  VOLTAGE_RMS_CALIBRATION: 0X4130,
  READ_VALUE_VOLTAGE_RMS: 0x4108,
  CURRENT_RMS_CALIBRATION: 0X4330,
  READ_VALUE_CURRENT_RMS: 0X4308,
  ACTIVE_POWER_CALIBRATION: 0X4430,
  READ_VALUE_ACTIVE_POWER: 0X4408,
  RESET_METER: 0x4A28,
  PERIODIC_SENDING: 0x4A08,
  ENABLE_SCHEDULING: 0x7120,
  SCHEDULING_INDEX_READ: 0x7108,
  SCHEDULING_INDEX_INSERT: 0x7128,
  SCHEDULING_INDEX_DELETE: 0x7130,
  SPECIAL_DAYS_INDEX_READ: 0x7208,
  SPECIAL_DAYS_INDEX_INSERT: 0x7210,
  SPECIAL_DAYS_INDEX_DELETE: 0x7218,
  LINK_CHECK: 0x6508,
  LINK_CHECK_CONFIRMATION: 0x6538,
  ALARM_LAST_ENTRIES: 0x6308,
  ALARM_RECOVERY_ENTRIES_INDEX: 0x6310,
  ALARM_RECOVERY_ENTRIES_TIMESTAMP: 0x6318,
  ALARM_CONFIRM: 0x6338,
  ALARM_THRESHOLD: 0x6408,
  ALARM_ENABLE: 0x6410,
  ALARM_ENABLE_SEND: 0x6418,
  ALARM_ACTIVATION_TIME: 0x6420,
  ALARM_RANDOM_SENDING_TIME: 0x6428
});
var _default = exports.default = VariableName;