"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _InformationReport = _interopRequireDefault(require("./InformationReport.js"));
var _WriteRequest = _interopRequireDefault(require("./WriteRequest.js"));
var _WriteResponse = _interopRequireDefault(require("./WriteResponse.js"));
var _SetRequest = _interopRequireDefault(require("./SetRequest.js"));
var _SetResponse = _interopRequireDefault(require("./SetResponse.js"));
var _ActionRequest = _interopRequireDefault(require("./ActionRequest.js"));
var _ActionResponse = _interopRequireDefault(require("./ActionResponse.js"));
var _GetRequest = _interopRequireDefault(require("./GetRequest.js"));
var _GetResponse = _interopRequireDefault(require("./GetResponse.js"));
var _DataNotification = _interopRequireDefault(require("./DataNotification.js"));
var _ReadRequest = _interopRequireDefault(require("./ReadRequest.js"));
var _ReadResponse = _interopRequireDefault(require("./ReadResponse.js"));
var _UnconfirmedWriteRequest = _interopRequireDefault(require("./UnconfirmedWriteRequest.js"));
var _GlobalBlockTransfer = _interopRequireDefault(require("./GlobalBlockTransfer.js"));
var _MessageType = _interopRequireDefault(require("../enum/MessageType.js"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
// Message.js - Converted from the C# Message class

class Message {
  static factory(bytes) {
    switch (bytes[0]) {
      case _MessageType.default.INFORMATION_REPORT:
        return new _InformationReport.default(bytes);
      case _MessageType.default.WRITE_REQUEST:
        return new _WriteRequest.default();
      case _MessageType.default.WRITE_RESPONSE:
        return new _WriteResponse.default(bytes);
      case _MessageType.default.SET_REQUEST:
        return new _SetRequest.default();
      case _MessageType.default.SET_RESPONSE:
        return new _SetResponse.default(bytes);
      case _MessageType.default.ACTION_REQUEST:
        return new _ActionRequest.default();
      case _MessageType.default.ACTION_RESPONSE:
        return new _ActionResponse.default(bytes);
      case _MessageType.default.GET_REQUEST:
        return new _GetRequest.default();
      case _MessageType.default.GET_RESPONSE:
        return new _GetResponse.default(bytes);
      case _MessageType.default.DATA_NOTIFICATION:
        return new _DataNotification.default(bytes);
      case _MessageType.default.READ_REQUEST:
        return new _ReadRequest.default();
      case _MessageType.default.READ_RESPONSE:
        return new _ReadResponse.default(bytes);
      case _MessageType.default.UNCONFIRMED_WRITE_REQUEST:
        return new _UnconfirmedWriteRequest.default();
      case _MessageType.default.GLOBAL_BLOCK_TRANSFER:
        return new _GlobalBlockTransfer.default(bytes);
      default:
        throw new Error("Unsupported MessageType: ".concat(bytes[0]));
    }
  }
}
exports.default = Message;