"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _DlmsArray = _interopRequireDefault(require("./DlmsArray.js"));
var _DlmsArrayStruct = _interopRequireDefault(require("./DlmsArrayStruct.js"));
var _Boolean = _interopRequireDefault(require("./Boolean.js"));
var _DlmsBitstring = _interopRequireDefault(require("./DlmsBitstring.js"));
var _DlmsInt = _interopRequireDefault(require("./DlmsInt8.js"));
var _DlmsUint = _interopRequireDefault(require("./DlmsUint8.js"));
var _DlmsUint2 = _interopRequireDefault(require("./DlmsUint16.js"));
var _DlmsUint3 = _interopRequireDefault(require("./DlmsUint32.js"));
var _DlmsUint4 = _interopRequireDefault(require("./DlmsUint64.js"));
var _DlmsOctetString = _interopRequireDefault(require("./DlmsOctetString.js"));
var _DlmsString = _interopRequireDefault(require("./DlmsString.js"));
var _DlmsEnum = _interopRequireDefault(require("./DlmsEnum.js"));
var _DlmsCompactArray = _interopRequireDefault(require("./DlmsCompactArray.js"));
var _DlmsDataType = _interopRequireDefault(require("../enum/DlmsDataType.js"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class DlmsDatas {
  static factory(type) {
    switch (type) {
      case _DlmsDataType.default.ARRAY:
        return new _DlmsArray.default();
      case _DlmsDataType.default.STRUCT:
        return new _DlmsArrayStruct.default();
      case _DlmsDataType.default.BOOLEAN:
        return new _Boolean.default();
      case _DlmsDataType.default.BITSTRING:
        return new _DlmsBitstring.default();
      case _DlmsDataType.default.INT8:
        return new _DlmsInt.default();
      case _DlmsDataType.default.UINT8:
        return new _DlmsUint.default();
      case _DlmsDataType.default.UINT16:
        return new _DlmsUint2.default();
      case _DlmsDataType.default.UINT32:
        return new _DlmsUint3.default();
      case _DlmsDataType.default.UINT64:
        return new _DlmsUint4.default();
      case _DlmsDataType.default.OCTET_STRING:
        return new _DlmsOctetString.default();
      case _DlmsDataType.default.STRING:
        return new _DlmsString.default();
      case _DlmsDataType.default.ENUM:
        return new _DlmsEnum.default();
      case _DlmsDataType.default.COMPACT_ARRAY:
        return new _DlmsCompactArray.default();
      default:
        throw new Error("Unsupported DlmsDataType: ".concat(type));
    }
  }
}
exports.default = DlmsDatas;