"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.regexp.to-string.js");
require("core-js/modules/esnext.iterator.map.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _DlmsDatas = _interopRequireDefault(require("../typesDLMS/DlmsDatas"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class ReadResponse {
  constructor() {
    let bytes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    this.qty = 0;
    this.parameterType = 0;
    this.dlmsData = null;
    this.dataAccessResult = null;
    this.value = [];
    if (bytes) {
      this.insertData(bytes);
    }
  }
  insertData(bytes) {
    this.value = [...bytes]; // Clone the byte array
    this.qty = bytes[1];
    this.parameterType = bytes[2];
    if (this.parameterType === 0) {
      const dataType = bytes[3];
      this.dlmsData = _DlmsDatas.default.factory(dataType);
      const temp = bytes.slice(3); // Extract the remaining bytes starting from index 3
      this.dlmsData.insertData(temp);
    } else {
      this.dataAccessResult = bytes[3]; // Assume mapping to `DataAccessResult` is handled elsewhere
    }
  }
  getBytes() {
    throw new Error("Method not implemented.");
  }
  getHexString() {
    return this.value.map(byte => byte.toString(16).toUpperCase().padStart(2, '0')).join(' ');
  }
}
exports.default = ReadResponse;